
/*  field definitions */


private static final String   IIH_HEADER_STRUCT_ID    = "IIH ";
private static final int      IIH_HEADER_VERSION      = 1;
private static final int      IIH_HEADER_LENGTH       = 84;
private static final int      IIH_HEADER_ENCODING     = 0;
private static final int      IIH_HEADER_CODECHARSET  = 0;
private static final String   IIH_HEADER_FORMAT       = "MQIMSVS ";
private static final int      IIH_HEADER_FLAGS        = 0;
private static final String   IIH_HEADER_LTERM_OR     = "        ";
private static final String   IIH_HEADER_MFS_MAPNAME  = "        ";
private static final String   IIH_HEADER_REPLY_FORMAT = "MQIMSVS ";
private static final String   IIH_HEADER_MFS_AUTH     = "        ";
private static final byte[]   IIH_HEADER_TRAN_INSTANCE = {
                                      00, 00, 00, 00, 00, 00, 00, 00,
                                      00, 00, 00, 00, 00, 00, 00, 00 };
private static final String   IIH_HEADER_TRAN_STATE     = " ";
private static final String   IIH_HEADER_SECURITY_SCOPE = "C";
private static final String   IIH_HEADER_RESERVED       = " ";



//MQPUT block follows
try
{
   String myRequest = "My message to send";

   MQMessage putMsg = new MQMessage();
   putMsg.format = "MQIMS";
   putMsg.persistence = 0;
   // Write IIH-Header
   putMsg.writeString(IIH_HEADER_STRUCT_ID);
   putMsg.writeInt(IIH_HEADER_VERSION);
   putMsg.writeInt(IIH_HEADER_LENGTH);
   putMsg.writeInt(IIH_HEADER_ENCODING);
   putMsg.writeInt(IIH_HEADER_CODECHARSET);
   putMsg.writeString(IIH_HEADER_FORMAT);
   putMsg.writeInt(IIH_HEADER_FLAGS);
   putMsg.writeString(IIH_HEADER_LTERM_OR);
   putMsg.writeString(IIH_HEADER_MFS_MAPNAME);
   putMsg.writeString(IIH_HEADER_REPLY_FORMAT);
   putMsg.writeString(IIH_HEADER_MFS_AUTH);
   putMsg.write(IIH_HEADER_TRAN_INSTANCE);
   putMsg.writeString(IIH_HEADER_TRAN_STATE);
   putMsg.writeString( "1" );  // IIH commit mode, value dependent of persistence type
   putMsg.writeString(IIH_HEADER_SECURITY_SCOPE);
   putMsg.writeString(IIH_HEADER_RESERVED);

   int msgLength = myRequest.length() + 9 + 4;
   // Write llzz divider.
   // The length includes transcode 9 bytes, llzz 4 bytes and datamsg.length
   putMsg.writeShort(msgLength);
   putMsg.writeByte(00);
   putMsg.writeByte(00);
   // Append IMS - transactioncode 9 characters
   putMsg.writeString("xxxxxxxx ");
   putMsg.writeString(myRequest);



  //put message to queue (assumed MQQueue queue opened elsewhere)
  pmo = new MQPutMessageOptions();
  queue.put(putMsg,pmo);

}
catch(MQException ex)
{
  System.err.println("MQPUT failed with error code: " + ex.reasonCode);
}
